## QB Bootcamp Exercise 5
################################################################################
## In this exerice you will learn about working with dictionaries

## You could translate from DNA to AA using a 64-way if statement, but is often
## more convenient to use a "dictionary" to map from codons to AA characters

## declare the empty dictionary
codon2aa = {}

## now fill it in!
codon2aa["UUU"] = "F"
codon2aa["CUU"] = "L"
codon2aa["AUU"] = "I"
codon2aa["GUU"] = "V"
codon2aa["UUC"] = "F"
codon2aa["CUC"] = "L"
codon2aa["AUC"] = "I"
codon2aa["GUC"] = "V"
codon2aa["UUA"] = "L"
codon2aa["CUA"] = "L"
codon2aa["AUA"] = "I"
codon2aa["GUA"] = "V"
codon2aa["UUG"] = "L"
codon2aa["CUG"] = "L"
codon2aa["AUG"] = "M"
codon2aa["GUG"] = "V"
codon2aa["UCU"] = "S"
codon2aa["CCU"] = "P"
codon2aa["ACU"] = "T"
codon2aa["GCU"] = "A"
codon2aa["UCC"] = "S"
codon2aa["CCC"] = "P"
codon2aa["ACC"] = "T"
codon2aa["GCC"] = "A"
codon2aa["UCA"] = "S"
codon2aa["CCA"] = "P"
codon2aa["ACA"] = "T"
codon2aa["GCA"] = "A"
codon2aa["UCG"] = "S"
codon2aa["CCG"] = "P"
codon2aa["ACG"] = "T"
codon2aa["GCG"] = "A"
codon2aa["UAU"] = "Y"
codon2aa["CAU"] = "H"
codon2aa["AAU"] = "N"
codon2aa["GAU"] = "D"
codon2aa["UAC"] = "Y"
codon2aa["CAC"] = "H"
codon2aa["AAC"] = "N"
codon2aa["GAC"] = "D"
codon2aa["UAA"] = "*"
codon2aa["CAA"] = "Q"
codon2aa["AAA"] = "K"
codon2aa["GAA"] = "E"
codon2aa["UAG"] = "*"
codon2aa["CAG"] = "Q"
codon2aa["AAG"] = "K"
codon2aa["GAG"] = "E"
codon2aa["UGU"] = "C"
codon2aa["CGU"] = "R"
codon2aa["AGU"] = "S"
codon2aa["GGU"] = "G"
codon2aa["UGC"] = "C"
codon2aa["CGC"] = "R"
codon2aa["AGC"] = "S"
codon2aa["GGC"] = "G"
codon2aa["UGA"] = "*"
codon2aa["CGA"] = "R"
codon2aa["AGA"] = "R"
codon2aa["GGA"] = "G"
codon2aa["UGG"] = "W"
codon2aa["CGG"] = "R"
codon2aa["AGG"] = "R"
codon2aa["GGG"] = "G"



## Example of how to look up a single codon
codon = "CAA"
aa = codon2aa[codon]
print "%s => %s" % (codon, aa)


## Be careful, it will yell at you if you look up something that doesnt exist
bogus_codon = "XXX"
aa = codon2aa[bogus_codon]
print aa


## You can check if a given codon exists in the hash table first

if (bogus_codon in codon2aa):
    print "%s => %s" % (bogus_codon, codon2aa[bogus_codon])
else:
    print "not found!"
    
## or you can use a default value
aa = codon2aa.get(bogus_codon, "?")
print aa




## Challenge problem: translate this mRNA to an AA sequence

gene = "UGUUCUCAUCUUAUUUCUUUUGUCAAU"


## Hint: this will extract the first 3 letters of the gene sequence
codon = gene[0:3]
print codon


aaseq = ""

## insert magic here
    
print aaseq