## URP Bootcamp Exercise 6
################################################################################
## In this exercise you will find a DNA binding motif from the DNA60IFX challenge
## Using the sequences from: http://genomebiology.com/about/update/DNA60_STEPONE


## Scan the sequences and count the number of times each kmer occurs
###############################################################################

# reset the kmers table
kmers = {}

## define the kmer length
k = 7

linenum = 0
numsequences = 0
numbases = 0
verbose = True

## open the file with the sequences, processing it line by line
## make sure you set the working directory to match the editor directory!
f = open("motif_finding.fa")

# read each line of the file
for line in f:
    linenum += 1
    
    # chop of the newline at the end
    line = line.rstrip()

    if (line[0] == ">"):
        if (verbose): print "Processing sequence: " + line
        numsequences += 1
        
    else:
        if (verbose): print line;
        numbases += len(line)
        
        ## TODO: Extract the kmers and update the dictionary
    
    if (linenum > 10):
        break

print "Processed %d lines, %d sequences, %d total bases" % (linenum, numsequences, numbases)
print "There were %d distinct kmers in the data" % len(kmers)






## Challenge questions
################################################################################

## 1. What was the most frequent kmer?
## 2. How many kmers occur more than 10 or 100 times?
## 3. How would you compute the mean and standard deviation of kmer frequency